// (c) 2016, SAS Institute Inc.
sap.ui.define([
    "sas/hc/m/MenuItem"
], function(SasHCMMenuItem) {
    "use strict";

    /**
     * Constructor for a new MenuItem.
     *
     * The overflow menu uses MenuItems to represent action buttons.
     * This extension of MenuItem simply add an association to make
     * keeping track of which action button corresponds to which MenuItem easier.
     *
     * @class
     * @name sas.hc.m.objectInspector.OIMenuItem
     * @extends sas.hc.m.MenuItem
     * @version 207001.0.1.20170511082246_f0htmcm27p
     * @author Jonathan Brink
     * @constructor
     * @public
     */
    var OIMenuItem = SasHCMMenuItem.extend("sas.hc.m.objectInspector.OIMenuItem", /** @lends sas.hc.m.objectInspector.MenuItem.prototype */ {
        metadata: {
            library: "sas.hc.m",
            associations: {
                button: { type: "sas.hc.m.Button", multiple: false }
            }
        },
        renderer: {
        }
    });

    return OIMenuItem;
}, /* bExport= */ true);
