/*
 * Copyright 2014 SAS Institute Inc.
 * All Rights Reserved.
 *
 * NOTE: This is a generated file. Changes should be made in the underlying
 * source files (*.js, .library, etc) or they will be lost after the next generation
*/

jQuery.sap.declare("sas.ltjs.commons.library");
jQuery.sap.require("sap.ui.core.Core");
jQuery.sap.require("sas.hc.ui.core.util");

/**
 * @namespace
 * @name sas.ltjs.commons
 * @public
*/

// delegate further initialization of this library to the Core
sap.ui.getCore().initLibrary({
  name : "sas.ltjs.commons",
  dependencies : ["sap.ui.core"],
  noLibraryCSS: true,
  types : [
  ],
  interfaces : [
  ],
  controls : [
  ],
  elements : [
  ],
  version : "207001.0.0.20170511073254_f0htmcm27p"});

sas.ltjs.isOpenUI = true;

(function(){
  "use strict";

  //Coppied from sap-ui-core.js
  // Name conversion function that converts a name in unified resource name syntax to a name in UI5 module name syntax.
  var urnToUI5 = function(sName) {
      var sResult;
      
      // UI5 module name syntax is only defined for JS resources
      if ( !/\.js$/.test(sName) ) {
          return null;
      }
      
      sName = sName.slice(0, -3);
      if ( /^sap\/ui\/thirdparty\/jquery\/jquery-/.test(sName) ) {
          return "sap.ui.thirdparty.jquery.jquery-" + sName.slice("sap/ui/thirdparty/jquery/jquery-".length);
      } else if ( /^jquery\.sap\./.test(sName) ) {
          return sName; // do nothing
      }
      return sName.replace(/\//g, ".");
  };

  //can't do relative paths since I don't know where in the stack we are.
  var require = function(fullPath) {
       var uiReq = urnToUI5(fullPath + ".js");
       jQuery.sap.require(uiReq);
       var paths = fullPath.split("/");
       var space = window;
       for(var i = 0, length = paths.length; i < length; ++i){
          space = space[paths[i]];
       }
       return space;
  };

  // A list of LTJS wrapper library dependencies that have been loaded.
  var ltjsDependencies = [];

  var baseResourceLocation = "sas/ltjslib";
  var resourceLocation = null;

  var calculateResourceLocation = function() {
    if(!resourceLocation) {
      resourceLocation = baseResourceLocation;

      if(!sas.ltjs.__useBaseResourceLocation) {
        // Sort the dependencies.
        ltjsDependencies.sort();
        // calculate the resource location suffix, "/dependencyA/dependencyB"...
        var resourceLocationSuffix = "";
        for(var i = 0; i < ltjsDependencies.length; i++) {
          var library = ltjsDependencies[i];
          if (library !== "sasicu") { // special case sasicu
            resourceLocationSuffix += "/" + library;
          }
        }

        if(resourceLocationSuffix) {
          // Set the new resourceLocation as well as register this new location
          // with openui5 so that any request for something in sas.ltjslib (baseResourceLocation)
          // resolves to request for that module at the new calculate path.
          resourceLocation = baseResourceLocation + resourceLocationSuffix;
          // Calculate the full resource path by adding the new suffix to the old path
          var newResourcePath = jQuery.sap.getResourcePath(baseResourceLocation,'') + resourceLocationSuffix;
          jQuery.sap.registerResourcePath(baseResourceLocation, newResourcePath);
        }
      }
    }
  };

  sas.ltjs.define = function(id, dependencies, module) {
      // Force the initialization of the resoureceLocation.
      // Must be done before a sas/ltjslib/* is pulled in as
      // a dependency.
      calculateResourceLocation();

      var indexOfRequire = -1;//, indexOfExports, indexOfModule;
      var args = [id, dependencies, module];
      var i, length;
      if(typeof id !== "string") {
          module = dependencies;
          dependencies = id;
          id = null;
          args.pop();
      }
      if(!Array.isArray(dependencies)) {
        args.pop();
        module = dependencies;
        dependencies = null;
      }

      if(dependencies) {
        indexOfRequire = dependencies.indexOf("require");
        // indexOfExports = dependencies.indexOf("exports");
        // indexOfModule = dependencies.indexOf("module");

        if(indexOfRequire !== -1) {
            dependencies.splice(indexOfRequire, 1);
        }
      }

      //swap out the module to support "require"
      if(indexOfRequire !== -1 || !dependencies)  {
        args[args.length - 1 ] = function(){
            //for loop to avoid v8 deoptimization. https://github.com/petkaantonov/bluebird/wiki/Optimization-killers#3-managing-arguments
            args = [];
            for(i = 0, length = arguments.length; i < length; ++i) {
              args.push(arguments[i]);
            }
            if(indexOfRequire !== -1) {
                args.splice(indexOfRequire, 0, require);
            } else {
              args.push(require);
            }
            if( typeof module === "function") {
              return module.apply(window, args);
            }
            return module;
        };
      }

      //special case: ltjs.js does not export.
      if(!id || id !== "sas/ltjslib/ltjs") {
          args.push(true); //export
      }

      sap.ui.define.apply(window, args);
  };

  sas.ltjs.registerDependency = function(namespace) {
    if(namespace) {
      ltjsDependencies.push(namespace);
    }
  };

  sas.ltjs.getRegisteredDependencies = function() {
    return ltjsDependencies.slice();
  };

  sas.ltjs.getLibraryResourceLocation = function() {
    calculateResourceLocation();
    return resourceLocation;
  };

  // Express the sas.ltjs.commons dependency.
  // "sas.ltjs."" is implied.
  sas.ltjs.registerDependency("commons");

  sas.hc.ui.core.util.registerBootHook(function () {
    // Load the ltjsLoader asap, but not before all ltjs libraries have
    // loaded. Using a boot hook allows us to do this task after
    // core has initialized, which is when the libraries are loaded.
    jQuery.sap.require("sas.ltjs.ltjsLoader");
    var ltjsInitDeferred = jQuery.Deferred();
    sas.ltjs.ltjsLoader.runWhenInitialized(function () {
      //a little defensiive, but end of the release
      if(sas && sas.eventBus && sas.eventBus.publish) {
        sas.eventBus.publish("ltjs","loading_finished");
      }
      ltjsInitDeferred.resolve();
    });

    return ltjsInitDeferred.promise();
  });
})();
